"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classes_1 = require("codechain-sdk/lib/core/classes");
var stake = require("codechain-stakeholder-sdk");
var fs = require("fs");
var util = require("util");
var prompts = require("prompts");
var summerizer_1 = require("../summerizer");
var util_1 = require("../util");
exports.module = {
    command: "batch-delegate <distribution-file>",
    describe: "Batch manage delegations through distribution file",
    builder: function (args) {
        return args
            .positional("distribution-file", {
            desc: "File to describe the distribution of delegations",
            type: "string",
            normalize: true
        })
            .demandOption("distribution-file")
            .option("password-path", {
            desc: "Path to password file to unlock accounts",
            string: true,
            normalize: true,
            demand: true
        })
            .option("dry-run", {
            desc: "Do not execute transactions",
            boolean: true,
            default: false
        });
    },
    handler: util_1.asyncHandler(function (argv) { return __awaiter(void 0, void 0, void 0, function () {
        var input, passwords, dryRun, _a, sdk, blockNumber, summary, planned;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, BatchDelegation.fromFile(argv["distribution-file"])];
                case 1:
                    input = _b.sent();
                    return [4 /*yield*/, passwordsFromFile(argv["password-path"])];
                case 2:
                    passwords = _b.sent();
                    dryRun = argv["dry-run"];
                    return [4 /*yield*/, util_1.prologue(argv)];
                case 3:
                    _a = _b.sent(), sdk = _a.sdk, blockNumber = _a.blockNumber;
                    return [4 /*yield*/, summerizer_1.summarize(sdk, blockNumber)];
                case 4:
                    summary = _b.sent();
                    preCheck(input, summary);
                    return [4 /*yield*/, plan(input, summary)];
                case 5:
                    planned = _b.sent();
                    printPlan(planned);
                    return [4 /*yield*/, confirm()];
                case 6:
                    _b.sent();
                    return [4 /*yield*/, check(sdk, planned)];
                case 7:
                    _b.sent();
                    return [4 /*yield*/, execute(sdk, passwords, input.accounts, planned, dryRun)];
                case 8:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    }); })
};
function preCheck(input, summary) {
    var e_1, _a, e_2, _b;
    var totalCCSToDelegate = input.distributions
        .map(function (x) { return x.quantity; })
        .reduce(function (a, b) { return a.plus(b); }, new classes_1.U64(0));
    var availableCCS = new classes_1.U64(0);
    try {
        for (var _c = __values(input.accounts), _d = _c.next(); !_d.done; _d = _c.next()) {
            var account = _d.value;
            availableCCS = availableCCS.plus(summary.get(account).undelegated);
            try {
                for (var _e = (e_2 = void 0, __values(input.validators)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var delegatee = _f.value;
                    availableCCS = availableCCS.plus(summary.delegations(account, delegatee));
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (availableCCS.lt(totalCCSToDelegate)) {
        throw new Error("accounts' available CCS (" + availableCCS.toLocaleString() + ") are less than the sum of distributions (" + totalCCSToDelegate.toLocaleString() + ")");
    }
}
function plan(input, summary) {
    return __awaiter(this, void 0, void 0, function () {
        function setOrRemoveIfZero(map, key, value) {
            if (value.eq(0)) {
                map.delete(key);
            }
            else {
                map.set(key, value);
            }
        }
        function redelegate(delegator, prevDelegatee, nextDelegatee, quantity) {
            if (quantity.eq(0)) {
                return;
            }
            tracer.delegation(delegator, prevDelegatee).minus(quantity);
            tracer.delegation(delegator, nextDelegatee).plus(quantity);
            tracer.transactions.push({
                type: "redelegate",
                delegator: delegator.toString(),
                prevDelegatee: prevDelegatee.toString(),
                nextDelegatee: nextDelegatee.toString(),
                quantity: quantity,
                fee: input.fee
            });
        }
        function revoke(delegator, delegatee, quantity) {
            if (quantity.eq(0)) {
                return;
            }
            var undelegated = tracer.undelegated(delegator);
            undelegated.value = undelegated.value.plus(quantity);
            tracer.delegation(delegator, delegatee).minus(quantity);
            tracer.transactions.push({
                type: "revoke",
                delegator: delegator.toString(),
                delegatee: delegatee.toString(),
                quantity: quantity,
                fee: input.fee
            });
        }
        function delegate(delegator, delegatee, quantity) {
            if (quantity.eq(0)) {
                return;
            }
            var undelegated = tracer.undelegated(delegator);
            undelegated.value = undelegated.value.minus(quantity);
            tracer.delegation(delegator, delegatee).plus(quantity);
            tracer.transactions.push({
                type: "delegate",
                delegator: delegator.toString(),
                delegatee: delegatee.toString(),
                quantity: quantity,
                fee: input.fee
            });
        }
        function cap(upperLimit, baseline, want) {
            if (baseline.plus(want).lt(upperLimit)) {
                return want;
            }
            else {
                return upperLimit.minus(baseline);
            }
        }
        var tracer, _a, _b, account, _c, _d, validator, delegation, min, _e, _f, needRevoke, prev, toRevoke, accumulated, _g, _h, needDelegation, next, toDelegate, toRedelegate, _j, _k, account, delegation, quantity, _l, _m, _o, validator, toRevoke, accumulated, _p, _q, account, delegation, quantity, _r, _s, _t, validator, toDelegate, accumulated, _u, _v, account, undelegated, quantity;
        var e_3, _w, e_4, _x, e_5, _y, e_6, _z, e_7, _0, e_8, _1, e_9, _2, e_10, _3, e_11, _4;
        return __generator(this, function (_5) {
            tracer = {
                transactions: [],
                undelegateds: new Map(),
                undelegated: function (delegator) {
                    var key = delegator.toString();
                    var self = this;
                    return {
                        get value() {
                            return self.undelegateds.get(key) || new classes_1.U64(0);
                        },
                        set value(quantity) {
                            setOrRemoveIfZero(self.undelegateds, key, quantity);
                        }
                    };
                },
                delegations: new Map(),
                delegation: function (delegator, delegatee) {
                    var key = "" + delegator.toString() + delegatee.toString();
                    var self = this;
                    return {
                        get value() {
                            return self.delegations.get(key) || new classes_1.U64(0);
                        },
                        set value(quantity) {
                            setOrRemoveIfZero(self.delegations, key, quantity);
                        },
                        plus: function (quantity) {
                            this.value = this.value.plus(quantity);
                        },
                        minus: function (quantity) {
                            this.value = this.value.minus(quantity);
                        }
                    };
                },
                getNeedRevokes: function () {
                    var e_12, _a;
                    var _this = this;
                    var result = [];
                    var _loop_1 = function (validator, quantity) {
                        var delegations = input.accounts
                            .map(function (x) { return _this.delegation(x, validator).value; })
                            .reduce(classes_1.U64.plus, new classes_1.U64(0));
                        if (delegations.gt(quantity)) {
                            result.push({
                                validator: validator,
                                toRevoke: delegations.minus(quantity)
                            });
                        }
                    };
                    try {
                        for (var _b = __values(input.distributions), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var _d = _c.value, validator = _d.delegatee, quantity = _d.quantity;
                            _loop_1(validator, quantity);
                        }
                    }
                    catch (e_12_1) { e_12 = { error: e_12_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_12) throw e_12.error; }
                    }
                    return result;
                },
                getNeedDelegations: function () {
                    var e_13, _a;
                    var _this = this;
                    var result = [];
                    var _loop_2 = function (validator, quantity) {
                        var delegations = input.accounts
                            .map(function (x) { return _this.delegation(x, validator).value; })
                            .reduce(classes_1.U64.plus, new classes_1.U64(0));
                        if (quantity.gt(delegations)) {
                            result.push({
                                validator: validator,
                                toDelegate: quantity.minus(delegations)
                            });
                        }
                    };
                    try {
                        for (var _b = __values(input.distributions), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var _d = _c.value, validator = _d.delegatee, quantity = _d.quantity;
                            _loop_2(validator, quantity);
                        }
                    }
                    catch (e_13_1) { e_13 = { error: e_13_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_13) throw e_13.error; }
                    }
                    return result;
                }
            };
            try {
                // initialize tracer from summary
                for (_a = __values(input.accounts), _b = _a.next(); !_b.done; _b = _a.next()) {
                    account = _b.value;
                    tracer.undelegated(account).value = summary.get(account).undelegated;
                    try {
                        for (_c = (e_4 = void 0, __values(input.validators)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            validator = _d.value;
                            delegation = summary.delegations(account, validator);
                            tracer.delegation(account, validator).value = delegation;
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_x = _c.return)) _x.call(_c);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_w = _a.return)) _w.call(_a);
                }
                finally { if (e_3) throw e_3.error; }
            }
            min = function (lhs, rhs) { return (lhs.gt(rhs) ? rhs : lhs); };
            try {
                for (_e = __values(tracer.getNeedRevokes()), _f = _e.next(); !_f.done; _f = _e.next()) {
                    needRevoke = _f.value;
                    prev = needRevoke.validator, toRevoke = needRevoke.toRevoke;
                    accumulated = new classes_1.U64(0);
                    try {
                        revokeAll: for (_g = (e_6 = void 0, __values(tracer.getNeedDelegations())), _h = _g.next(); !_h.done; _h = _g.next()) {
                            needDelegation = _h.value;
                            next = needDelegation.validator, toDelegate = needDelegation.toDelegate;
                            toRedelegate = min(toRevoke, toDelegate);
                            try {
                                for (_j = (e_7 = void 0, __values(input.accounts)), _k = _j.next(); !_k.done; _k = _j.next()) {
                                    account = _k.value;
                                    delegation = tracer.delegation(account, prev).value;
                                    quantity = cap(toRedelegate, accumulated, delegation);
                                    accumulated = accumulated.plus(quantity);
                                    redelegate(account, prev, next, quantity);
                                    if (accumulated.isEqualTo(toRevoke)) {
                                        break revokeAll; // to get next needRevoke;
                                    }
                                    else if (accumulated.isEqualTo(toDelegate)) {
                                        break; // to get next needDelegation;
                                    }
                                }
                            }
                            catch (e_7_1) { e_7 = { error: e_7_1 }; }
                            finally {
                                try {
                                    if (_k && !_k.done && (_0 = _j.return)) _0.call(_j);
                                }
                                finally { if (e_7) throw e_7.error; }
                            }
                        }
                    }
                    catch (e_6_1) { e_6 = { error: e_6_1 }; }
                    finally {
                        try {
                            if (_h && !_h.done && (_z = _g.return)) _z.call(_g);
                        }
                        finally { if (e_6) throw e_6.error; }
                    }
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_y = _e.return)) _y.call(_e);
                }
                finally { if (e_5) throw e_5.error; }
            }
            try {
                // Plan Revoke
                for (_l = __values(tracer.getNeedRevokes()), _m = _l.next(); !_m.done; _m = _l.next()) {
                    _o = _m.value, validator = _o.validator, toRevoke = _o.toRevoke;
                    accumulated = new classes_1.U64(0);
                    try {
                        // Greedy: First come, first revoke.
                        for (_p = (e_9 = void 0, __values(input.accounts)), _q = _p.next(); !_q.done; _q = _p.next()) {
                            account = _q.value;
                            delegation = tracer.delegation(account, validator).value;
                            quantity = cap(toRevoke, accumulated, delegation);
                            accumulated = accumulated.plus(quantity);
                            revoke(account, validator, quantity);
                            if (accumulated.isEqualTo(toRevoke)) {
                                break;
                            }
                        }
                    }
                    catch (e_9_1) { e_9 = { error: e_9_1 }; }
                    finally {
                        try {
                            if (_q && !_q.done && (_2 = _p.return)) _2.call(_p);
                        }
                        finally { if (e_9) throw e_9.error; }
                    }
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (_m && !_m.done && (_1 = _l.return)) _1.call(_l);
                }
                finally { if (e_8) throw e_8.error; }
            }
            try {
                // Plan Delegate
                for (_r = __values(tracer.getNeedDelegations()), _s = _r.next(); !_s.done; _s = _r.next()) {
                    _t = _s.value, validator = _t.validator, toDelegate = _t.toDelegate;
                    accumulated = new classes_1.U64(0);
                    try {
                        // Greedy: First come, first delegate.
                        for (_u = (e_11 = void 0, __values(input.accounts)), _v = _u.next(); !_v.done; _v = _u.next()) {
                            account = _v.value;
                            undelegated = tracer.undelegated(account).value;
                            quantity = cap(toDelegate, accumulated, undelegated);
                            accumulated = accumulated.plus(quantity);
                            delegate(account, validator, quantity);
                            if (accumulated.isEqualTo(toDelegate)) {
                                break;
                            }
                        }
                    }
                    catch (e_11_1) { e_11 = { error: e_11_1 }; }
                    finally {
                        try {
                            if (_v && !_v.done && (_4 = _u.return)) _4.call(_u);
                        }
                        finally { if (e_11) throw e_11.error; }
                    }
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (_s && !_s.done && (_3 = _r.return)) _3.call(_r);
                }
                finally { if (e_10) throw e_10.error; }
            }
            return [2 /*return*/, tracer.transactions];
        });
    });
}
function printPlan(planned) {
    return __awaiter(this, void 0, void 0, function () {
        var table, i, tx, row, fees, planned_1, planned_1_1, tx, _a, _b, _c, delegator, fee;
        var e_14, _d, e_15, _e;
        return __generator(this, function (_f) {
            table = util_1.createTable([
                "Id",
                "Action",
                "Quantity",
                "Account",
                "Delegatee",
                "Next Delegatee(redelegate)"
            ]);
            for (i = 0; i < planned.length; i++) {
                tx = planned[i];
                row = [i, tx.type, tx.quantity.toLocaleString(), tx.delegator];
                switch (tx.type) {
                    case "delegate":
                        row.push(tx.delegatee, "");
                        break;
                    case "revoke":
                        row.push(tx.delegatee, "");
                        break;
                    case "redelegate":
                        row.push(tx.prevDelegatee, tx.nextDelegatee);
                        break;
                    default:
                        throw Error("never");
                }
                table.push(row);
            }
            fees = new Map();
            try {
                for (planned_1 = __values(planned), planned_1_1 = planned_1.next(); !planned_1_1.done; planned_1_1 = planned_1.next()) {
                    tx = planned_1_1.value;
                    fees.set(tx.delegator, (fees.get(tx.delegator) || 0) + tx.fee);
                }
            }
            catch (e_14_1) { e_14 = { error: e_14_1 }; }
            finally {
                try {
                    if (planned_1_1 && !planned_1_1.done && (_d = planned_1.return)) _d.call(planned_1);
                }
                finally { if (e_14) throw e_14.error; }
            }
            console.group("Transaction plan");
            {
                console.log(table.toString());
                console.group("Total Fee");
                try {
                    for (_a = __values(fees.entries()), _b = _a.next(); !_b.done; _b = _a.next()) {
                        _c = __read(_b.value, 2), delegator = _c[0], fee = _c[1];
                        console.log(delegator, fee.toLocaleString());
                    }
                }
                catch (e_15_1) { e_15 = { error: e_15_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                    }
                    finally { if (e_15) throw e_15.error; }
                }
                console.groupEnd();
            }
            console.groupEnd();
            return [2 /*return*/];
        });
    });
}
function confirm() {
    return __awaiter(this, void 0, void 0, function () {
        var answer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, prompts({
                        type: "confirm",
                        name: "value",
                        message: "Execute transactions?"
                    })];
                case 1:
                    answer = _a.sent();
                    if (answer.value !== true) {
                        throw new Error("Cancelled");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function check(sdk, planned) {
    return __awaiter(this, void 0, void 0, function () {
        var candidates, _a, planned_2, planned_2_1, tx, delegatee, fees, planned_3, planned_3_1, tx, fees_1, fees_1_1, _b, delegator, fee, balance, e_16_1;
        var e_17, _c, e_18, _d, e_16, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    _a = Set.bind;
                    return [4 /*yield*/, stake.getCandidates(sdk)];
                case 1:
                    candidates = new (_a.apply(Set, [void 0, (_f.sent()).map(function (x) {
                            return classes_1.PlatformAddress.fromPublic(x.pubkey, {
                                networkId: sdk.networkId
                            }).toString();
                        })]))();
                    try {
                        for (planned_2 = __values(planned), planned_2_1 = planned_2.next(); !planned_2_1.done; planned_2_1 = planned_2.next()) {
                            tx = planned_2_1.value;
                            delegatee = void 0;
                            if (tx.type === "delegate" || tx.type === "revoke") {
                                delegatee = tx.delegatee;
                            }
                            else {
                                delegatee = tx.nextDelegatee;
                            }
                            if (!candidates.has(delegatee)) {
                                throw new Error("Delegatee is not a candidate: " + delegatee);
                            }
                        }
                    }
                    catch (e_17_1) { e_17 = { error: e_17_1 }; }
                    finally {
                        try {
                            if (planned_2_1 && !planned_2_1.done && (_c = planned_2.return)) _c.call(planned_2);
                        }
                        finally { if (e_17) throw e_17.error; }
                    }
                    fees = new Map();
                    try {
                        for (planned_3 = __values(planned), planned_3_1 = planned_3.next(); !planned_3_1.done; planned_3_1 = planned_3.next()) {
                            tx = planned_3_1.value;
                            fees.set(tx.delegator, (fees.get(tx.delegator) || 0) + tx.fee);
                        }
                    }
                    catch (e_18_1) { e_18 = { error: e_18_1 }; }
                    finally {
                        try {
                            if (planned_3_1 && !planned_3_1.done && (_d = planned_3.return)) _d.call(planned_3);
                        }
                        finally { if (e_18) throw e_18.error; }
                    }
                    _f.label = 2;
                case 2:
                    _f.trys.push([2, 7, 8, 9]);
                    fees_1 = __values(fees), fees_1_1 = fees_1.next();
                    _f.label = 3;
                case 3:
                    if (!!fees_1_1.done) return [3 /*break*/, 6];
                    _b = __read(fees_1_1.value, 2), delegator = _b[0], fee = _b[1];
                    return [4 /*yield*/, sdk.rpc.chain.getBalance(delegator)];
                case 4:
                    balance = _f.sent();
                    if (balance < fee) {
                        throw new Error("Account " + delegator + " doesn't have enough CCC " + fee);
                    }
                    _f.label = 5;
                case 5:
                    fees_1_1 = fees_1.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_16_1 = _f.sent();
                    e_16 = { error: e_16_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (fees_1_1 && !fees_1_1.done && (_e = fees_1.return)) _e.call(fees_1);
                    }
                    finally { if (e_16) throw e_16.error; }
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    });
}
function execute(sdk, passwords, accounts, planned, dryRun) {
    return __awaiter(this, void 0, void 0, function () {
        var seqs, _a, txes, planned_4, planned_4_1, x, tx, passphrase, seq, signedTx, e_19, e_20_1, txHashes, results, txes_1, txes_1_1, tx, hash, table, i, result;
        var e_20, _b, e_21, _c;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _a = Map.bind;
                    return [4 /*yield*/, Promise.all(accounts.map(function (s) { return __awaiter(_this, void 0, void 0, function () {
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = [s.toString()];
                                        return [4 /*yield*/, sdk.rpc.chain.getSeq(s)];
                                    case 1: return [2 /*return*/, _a.concat([
                                            _b.sent()
                                        ])];
                                }
                            });
                        }); }))];
                case 1:
                    seqs = new (_a.apply(Map, [void 0, _d.sent()]))();
                    txes = [];
                    _d.label = 2;
                case 2:
                    _d.trys.push([2, 9, 10, 11]);
                    planned_4 = __values(planned), planned_4_1 = planned_4.next();
                    _d.label = 3;
                case 3:
                    if (!!planned_4_1.done) return [3 /*break*/, 8];
                    x = planned_4_1.value;
                    tx = void 0;
                    switch (x.type) {
                        case "delegate":
                            tx = stake.createDelegateCCSTransaction(sdk, x.delegatee, x.quantity);
                            break;
                        case "revoke":
                            tx = stake.createRevokeTransaction(sdk, x.delegatee, x.quantity);
                            break;
                        case "redelegate":
                            tx = stake.createRedelegateTransaction(sdk, x.prevDelegatee, x.nextDelegatee, x.quantity);
                            break;
                        default:
                            throw new Error("never");
                    }
                    _d.label = 4;
                case 4:
                    _d.trys.push([4, 6, , 7]);
                    passphrase = passwords.get(x.delegator);
                    seq = seqs.get(x.delegator);
                    seqs.set(x.delegator, seq + 1);
                    return [4 /*yield*/, sdk.key.signTransaction(tx, {
                            account: x.delegator,
                            passphrase: passphrase,
                            seq: seq,
                            fee: x.fee
                        })];
                case 5:
                    signedTx = _d.sent();
                    txes.push(signedTx);
                    return [3 /*break*/, 7];
                case 6:
                    e_19 = _d.sent();
                    throw new Error(e_19 + ", key: " + x.delegator.toString());
                case 7:
                    planned_4_1 = planned_4.next();
                    return [3 /*break*/, 3];
                case 8: return [3 /*break*/, 11];
                case 9:
                    e_20_1 = _d.sent();
                    e_20 = { error: e_20_1 };
                    return [3 /*break*/, 11];
                case 10:
                    try {
                        if (planned_4_1 && !planned_4_1.done && (_b = planned_4.return)) _b.call(planned_4);
                    }
                    finally { if (e_20) throw e_20.error; }
                    return [7 /*endfinally*/];
                case 11:
                    txHashes = txes.map(function (tx) { return tx.hash().toString(); });
                    results = new Map();
                    if (!dryRun) return [3 /*break*/, 12];
                    try {
                        for (txes_1 = __values(txes), txes_1_1 = txes_1.next(); !txes_1_1.done; txes_1_1 = txes_1.next()) {
                            tx = txes_1_1.value;
                            hash = tx.hash().toString();
                            results.set(hash, {
                                success: "skipped",
                                hash: hash
                            });
                        }
                    }
                    catch (e_21_1) { e_21 = { error: e_21_1 }; }
                    finally {
                        try {
                            if (txes_1_1 && !txes_1_1.done && (_c = txes_1.return)) _c.call(txes_1);
                        }
                        finally { if (e_21) throw e_21.error; }
                    }
                    return [3 /*break*/, 15];
                case 12: return [4 /*yield*/, Promise.all(txes.map(function (tx) { return __awaiter(_this, void 0, void 0, function () {
                        var result;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, sendTx(sdk, tx)];
                                case 1:
                                    result = _a.sent();
                                    if (result) {
                                        results.set(result.hash, result);
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    }); }))];
                case 13:
                    _d.sent();
                    return [4 /*yield*/, Promise.all(txHashes
                            .filter(function (hash) { return !results.has(hash); })
                            .map(function (hash) { return __awaiter(_this, void 0, void 0, function () {
                            var result;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, getResult(sdk, hash.toString())];
                                    case 1:
                                        result = _a.sent();
                                        results.set(result.hash, result);
                                        return [2 /*return*/];
                                }
                            });
                        }); }))];
                case 14:
                    _d.sent();
                    _d.label = 15;
                case 15:
                    table = util_1.createTable(["Index", "TxHash", "Success", "Error?"]);
                    for (i = 0; i < txHashes.length; i++) {
                        result = results.get(txHashes[i].toString());
                        table.push([i, result.hash, result.success, result.error || ""]);
                    }
                    console.group("Transaction result");
                    console.log(table.toString());
                    console.groupEnd();
                    console.log("ccstake show");
                    return [2 /*return*/];
            }
        });
    });
}
function sendTx(sdk, tx) {
    return __awaiter(this, void 0, void 0, function () {
        var hash, e_22;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    hash = tx.hash().toString();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, sdk.rpc.chain.sendSignedTransaction(tx)];
                case 2:
                    _a.sent();
                    return [2 /*return*/, null];
                case 3:
                    e_22 = _a.sent();
                    return [2 /*return*/, {
                            success: false,
                            hash: hash,
                            error: "Error in SendSignedTransaction " + e_22
                        }];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function getResult(sdk, hash, timeout) {
    if (timeout === void 0) { timeout = 20000; }
    return __awaiter(this, void 0, void 0, function () {
        var start, hint;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    start = Date.now();
                    _a.label = 1;
                case 1:
                    if (!true) return [3 /*break*/, 6];
                    return [4 /*yield*/, sdk.rpc.chain.containsTransaction(hash)];
                case 2:
                    if (!_a.sent()) return [3 /*break*/, 3];
                    return [2 /*return*/, { success: true, hash: hash }];
                case 3: return [4 /*yield*/, sdk.rpc.chain.getErrorHint(hash)];
                case 4:
                    hint = _a.sent();
                    if (hint !== null) {
                        return [2 /*return*/, {
                                success: false,
                                hash: hash,
                                error: hint
                            }];
                    }
                    _a.label = 5;
                case 5:
                    if (Date.now() - start > timeout) {
                        return [2 /*return*/, {
                                success: false,
                                hash: hash,
                                error: "Timeout"
                            }];
                    }
                    return [3 /*break*/, 1];
                case 6: return [2 /*return*/];
            }
        });
    });
}
var BatchDelegation = /** @class */ (function () {
    function BatchDelegation(params) {
        this.accounts = params.accounts;
        this.fee = params.fee;
        this.distributions = params.distributions;
    }
    BatchDelegation.fromFile = function (filename) {
        return __awaiter(this, void 0, void 0, function () {
            var file, json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, util.promisify(fs.readFile)(filename, "utf8")];
                    case 1:
                        file = _a.sent();
                        json = JSON.parse(file);
                        return [2 /*return*/, BatchDelegation.fromJSON(json)];
                }
            });
        });
    };
    BatchDelegation.fromJSON = function (json) {
        var accounts = json.accounts.map(function (x) {
            return classes_1.PlatformAddress.ensure(x);
        });
        checkUniqueSet(accounts.map(function (x) { return x.toString(); }));
        var fee = json.fee;
        var distributions = json.distributions.map(function (x) {
            return Distribution.fromJSON(x);
        });
        checkUniqueSet(distributions.map(function (x) { return x.delegatee.toString(); }));
        return new BatchDelegation({
            accounts: accounts,
            fee: fee,
            distributions: distributions
        });
    };
    Object.defineProperty(BatchDelegation.prototype, "validators", {
        get: function () {
            return this.distributions.map(function (x) { return x.delegatee; });
        },
        enumerable: true,
        configurable: true
    });
    return BatchDelegation;
}());
function checkUniqueSet(values) {
    var e_23, _a;
    var set = new Set();
    try {
        for (var values_1 = __values(values), values_1_1 = values_1.next(); !values_1_1.done; values_1_1 = values_1.next()) {
            var value = values_1_1.value;
            if (set.has(value)) {
                throw new Error("Duplicated entries: " + value);
            }
            set.add(value);
        }
    }
    catch (e_23_1) { e_23 = { error: e_23_1 }; }
    finally {
        try {
            if (values_1_1 && !values_1_1.done && (_a = values_1.return)) _a.call(values_1);
        }
        finally { if (e_23) throw e_23.error; }
    }
}
var Distribution = /** @class */ (function () {
    function Distribution(params) {
        this.delegatee = params.delegatee;
        this.quantity = params.quantity;
    }
    Distribution.fromJSON = function (json) {
        return new Distribution({
            delegatee: classes_1.PlatformAddress.ensure(json.delegatee),
            quantity: classes_1.U64.ensure(json.quantity)
        });
    };
    return Distribution;
}());
function passwordsFromFile(filename) {
    return __awaiter(this, void 0, void 0, function () {
        var file, json, passwords, json_1, json_1_1, entry, address, password;
        var e_24, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, util.promisify(fs.readFile)(filename, "utf8")];
                case 1:
                    file = _b.sent();
                    json = JSON.parse(file);
                    if (!Array.isArray(json)) {
                        throw new Error("PasswordFile format error");
                    }
                    passwords = new Map();
                    try {
                        for (json_1 = __values(json), json_1_1 = json_1.next(); !json_1_1.done; json_1_1 = json_1.next()) {
                            entry = json_1_1.value;
                            address = classes_1.PlatformAddress.ensure(entry.address);
                            if (typeof entry.password !== "string") {
                                throw new Error("PasswordFile password format error");
                            }
                            password = entry.password;
                            passwords.set(address.toString(), password);
                        }
                    }
                    catch (e_24_1) { e_24 = { error: e_24_1 }; }
                    finally {
                        try {
                            if (json_1_1 && !json_1_1.done && (_a = json_1.return)) _a.call(json_1);
                        }
                        finally { if (e_24) throw e_24.error; }
                    }
                    return [2 /*return*/, passwords];
            }
        });
    });
}
