"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var classes_1 = require("codechain-sdk/lib/core/classes");
var codechain_stakeholder_sdk_1 = require("codechain-stakeholder-sdk");
var strip_ansi_1 = require("strip-ansi");
var summerizer_1 = require("../summerizer");
var util_1 = require("../util");
exports.module = {
    command: "validators",
    describe: "Show validators",
    handler: util_1.asyncHandler(function (argv) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, sdk, blockNumber, _b, termMetadata, validators, candidates, jailed, banned, metadataMap, summary, table, desc, validators_1, validators_1_1, _c, pubkey, delegation, deposit, address, sortedCandidats_2, desc, table, sortedCandidats_1, sortedCandidats_1_1, _d, address, delegation, deposit, nominationEndsAt, metadata, table, jailed_1, jailed_1_1, _e, address, deposit, custodyUntil, releasedAt, table, banned_1, banned_1_1, address;
        var e_1, _f, e_2, _g, e_3, _h, e_4, _j;
        return __generator(this, function (_k) {
            switch (_k.label) {
                case 0: return [4 /*yield*/, util_1.prologue(argv)];
                case 1:
                    _a = _k.sent(), sdk = _a.sdk, blockNumber = _a.blockNumber;
                    return [4 /*yield*/, Promise.all([
                            codechain_stakeholder_sdk_1.getTermMetadata(sdk, blockNumber),
                            codechain_stakeholder_sdk_1.getValidators(sdk, blockNumber),
                            codechain_stakeholder_sdk_1.getCandidates(sdk, blockNumber),
                            codechain_stakeholder_sdk_1.getJailed(sdk, blockNumber),
                            codechain_stakeholder_sdk_1.getBanned(sdk, blockNumber)
                        ])];
                case 2:
                    _b = __read.apply(void 0, [_k.sent(), 5]), termMetadata = _b[0], validators = _b[1], candidates = _b[2], jailed = _b[3], banned = _b[4];
                    metadataMap = new Map(candidates.map(function (candidate) {
                        var address = classes_1.PlatformAddress.fromPublic(candidate.pubkey, {
                            networkId: sdk.networkId
                        });
                        return [address.toString(), candidate.metadata];
                    }));
                    return [4 /*yield*/, summerizer_1.summarize(sdk, blockNumber)];
                case 3:
                    summary = _k.sent();
                    console.log("Current Term:", termMetadata.currentTermId);
                    console.log("Last term finished block:", termMetadata.lastTermFinishedBlockNumber);
                    console.group("Validators:");
                    {
                        table = util_1.createTable([
                            "Address",
                            "Delegation (CCS)",
                            "Deposit (CCC)",
                            "Metadata"
                        ]);
                        desc = function (a, b) {
                            if (a.delegation.gt(b.delegation)) {
                                return -1;
                            }
                            if (a.delegation.lt(b.delegation)) {
                                return 1;
                            }
                            if (a.deposit.gt(b.deposit)) {
                                return -1;
                            }
                            if (a.deposit.lt(b.deposit)) {
                                return 1;
                            }
                            return 0;
                        };
                        validators.sort(desc);
                        try {
                            for (validators_1 = __values(validators), validators_1_1 = validators_1.next(); !validators_1_1.done; validators_1_1 = validators_1.next()) {
                                _c = validators_1_1.value, pubkey = _c.pubkey, delegation = _c.delegation, deposit = _c.deposit;
                                address = classes_1.PlatformAddress.fromPublic(pubkey, {
                                    networkId: sdk.networkId
                                }).toString();
                                table.push([
                                    address,
                                    delegation.toLocaleString(),
                                    deposit.toLocaleString(),
                                    escapeMetadata(metadataMap.get(address))
                                ]);
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (validators_1_1 && !validators_1_1.done && (_f = validators_1.return)) _f.call(validators_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        console.log(table.toString());
                    }
                    console.groupEnd();
                    console.group("Candidates: ");
                    {
                        sortedCandidats_2 = candidates.map(function (c) {
                            var address = classes_1.PlatformAddress.fromPublic(c.pubkey, {
                                networkId: sdk.networkId
                            });
                            var delegation = summary.get(address).delegationsFrom.sum;
                            return __assign(__assign({}, c), { address: address, delegation: delegation });
                        });
                        desc = function (a, b) {
                            if (a.delegation.gt(b.delegation)) {
                                return -1;
                            }
                            if (a.delegation.lt(b.delegation)) {
                                return 1;
                            }
                            if (a.deposit.gt(b.deposit)) {
                                return -1;
                            }
                            if (a.deposit.lt(b.deposit)) {
                                return 1;
                            }
                            return 0;
                        };
                        sortedCandidats_2.sort(desc);
                        table = util_1.createTable([
                            "Address",
                            "Delegation (CCS)",
                            "Deposit (CCC)",
                            "Ends at (Term)",
                            "Metadata"
                        ]);
                        try {
                            for (sortedCandidats_1 = __values(sortedCandidats_2), sortedCandidats_1_1 = sortedCandidats_1.next(); !sortedCandidats_1_1.done; sortedCandidats_1_1 = sortedCandidats_1.next()) {
                                _d = sortedCandidats_1_1.value, address = _d.address, delegation = _d.delegation, deposit = _d.deposit, nominationEndsAt = _d.nominationEndsAt, metadata = _d.metadata;
                                table.push([
                                    address.toString(),
                                    delegation.toLocaleString(),
                                    deposit.toLocaleString(),
                                    nominationEndsAt.toString(),
                                    escapeMetadata(metadata)
                                ]);
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (sortedCandidats_1_1 && !sortedCandidats_1_1.done && (_g = sortedCandidats_1.return)) _g.call(sortedCandidats_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        console.log(table.toString());
                    }
                    console.groupEnd();
                    console.group("Jailed: ");
                    {
                        table = util_1.createTable([
                            "Address",
                            "Deposit (CCC)",
                            "Custody until(Term)",
                            "Ends at (Term)"
                        ]);
                        try {
                            for (jailed_1 = __values(jailed), jailed_1_1 = jailed_1.next(); !jailed_1_1.done; jailed_1_1 = jailed_1.next()) {
                                _e = jailed_1_1.value, address = _e.address, deposit = _e.deposit, custodyUntil = _e.custodyUntil, releasedAt = _e.releasedAt;
                                table.push([
                                    address.toString(),
                                    deposit.toLocaleString(),
                                    custodyUntil.toString(),
                                    releasedAt.toString()
                                ]);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (jailed_1_1 && !jailed_1_1.done && (_h = jailed_1.return)) _h.call(jailed_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        console.log(table.toString());
                    }
                    console.groupEnd();
                    console.group("Banned: ");
                    {
                        table = util_1.createTable(["Address"]);
                        try {
                            for (banned_1 = __values(banned), banned_1_1 = banned_1.next(); !banned_1_1.done; banned_1_1 = banned_1.next()) {
                                address = banned_1_1.value;
                                table.push([address.toString()]);
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (banned_1_1 && !banned_1_1.done && (_j = banned_1.return)) _j.call(banned_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        console.log(table.toString());
                    }
                    console.groupEnd();
                    return [2 /*return*/];
            }
        });
    }); })
};
function escapeMetadata(metadata) {
    if (metadata === undefined) {
        return "";
    }
    else {
        return strip_ansi_1.default(metadata.toString());
    }
}
