import { PlatformAddressValue } from "codechain-primitives/lib";
import { SDK } from "codechain-sdk";
import { PlatformAddress, U64 } from "codechain-sdk/lib/core/classes";
import { Delegation } from "codechain-stakeholder-sdk";
interface DelegationFrom {
    delegator: PlatformAddress;
    quantity: U64;
}
declare class QuantitySummerizableArray<T extends {
    quantity: U64;
}> {
    values: T[];
    private _sum?;
    readonly sum: U64;
}
export declare class AccountSummary {
    readonly balance: U64;
    undelegated: U64;
    delegationsTo: QuantitySummerizableArray<Delegation>;
    delegationsFrom: QuantitySummerizableArray<DelegationFrom>;
}
export interface Summary {
    totalCCS: U64;
    accounts: PlatformAddress[];
    get(account: PlatformAddressValue): AccountSummary;
    delegations(delegator: PlatformAddressValue, delegatee: PlatformAddressValue): U64;
}
export declare function summarize(sdk: SDK, blockNumber: number): Promise<Summary>;
export declare function sumU64(values: U64[]): U64;
export {};
